#! /bin/sh
# postinst script for xivo-ctid
#
# see: dh_installdeb(1)

set -e

DATA_DIR="/var/lib/consul"
MASTER_TOKEN_FILE="${DATA_DIR}/master_token"
DEFAULT_XIVO_CONSUL_CONFIG="${DATA_DIR}/default_xivo_consul_config.yml"
DEFAULT_XIVO_CONSUL_TOKEN="${DATA_DIR}/default_xivo_consul_token.yml"
DEFAULT_CONFIG="/etc/consul/xivo/config.json"
USER=consul
GROUP=${USER}

case "$1" in
    configure)
        # In version < 15.12 consul data were in /usr/lib/consul
        if [ -d "/usr/lib/consul" ]; then
            mv /usr/lib/consul/* "${DATA_DIR}"
            rmdir "/usr/lib/consul"
        fi

        # add/update user
        if ! getent passwd $USER > /dev/null ; then
            echo "Adding system user $USER" 1>&2
            adduser --quiet --system --group --no-create-home \
                --home /var/lib/consul \
                --gecos "Consul discovery service" \
                $USER
        else
            if dpkg --compare-versions "$2" lt '0.6.4~xivo2'; then
                usermod --shell /bin/false $USER
            fi
        fi

        # Be able to read key/certificate for HTTPS
        adduser --quiet $USER www-data

        # Change ownership to consul:consul
        chown -R ${USER}:${GROUP} /etc/consul
        chown -R ${USER}:${GROUP} ${DATA_DIR}

        # Create the master token file
        if [ ! -f ${MASTER_TOKEN_FILE} ]; then
            touch ${MASTER_TOKEN_FILE}
            chown ${USER}:${GROUP} ${MASTER_TOKEN_FILE}
            chmod 600 ${MASTER_TOKEN_FILE}
            token=$(od -An -tx4 -N32 -w /dev/urandom | tr -d " ")
            echo ${token} > ${MASTER_TOKEN_FILE}
        fi

        token=$(cat ${MASTER_TOKEN_FILE})

        touch ${DEFAULT_CONFIG}
        chown ${USER}:${GROUP} ${DEFAULT_CONFIG}
        chmod 600 ${DEFAULT_CONFIG}
        cat > ${DEFAULT_CONFIG} <<EOF
{
    "acl_default_policy": "deny",
    "acl_master_token": "${token}",
    "acl_datacenter": "$(hostname -s)",
    "datacenter": "$(hostname -s)",
    "server": true,
    "bind_addr": "127.0.0.1",
    "advertise_addr": "127.0.0.1",
    "client_addr": "127.0.0.1",
    "bootstrap_expect": 1,
    "rejoin_after_leave": true,
    "data_dir": "${DATA_DIR}",
    "enable_syslog": true,
    "disable_update_check": true,
    "log_level": "INFO",
    "ports": {
        "dns": -1,
        "http": -1,
        "https": 8500
    },
    "cert_file": "/usr/share/xivo-certs/server.crt",
    "key_file": "/usr/share/xivo-certs/server.key"
}
EOF

        # Create the default config file for XiVO services
        touch ${DEFAULT_XIVO_CONSUL_CONFIG}
        chown ${USER}:${GROUP} ${DEFAULT_XIVO_CONSUL_CONFIG}
        chmod 640 ${DEFAULT_XIVO_CONSUL_CONFIG}
        cat > ${DEFAULT_XIVO_CONSUL_CONFIG} <<EOF
consul:
    scheme: https
    host: localhost
    port: 8500
    verify: /usr/share/xivo-certs/server.crt
EOF
        # Create the master token config file for XiVO services
        touch ${DEFAULT_XIVO_CONSUL_TOKEN}
        chown ${USER}:${GROUP} ${DEFAULT_XIVO_CONSUL_TOKEN}
        chmod 640 ${DEFAULT_XIVO_CONSUL_TOKEN}
        cat > ${DEFAULT_XIVO_CONSUL_TOKEN} <<EOF
consul:
    token: ${token}
EOF

        # systemd migration
        drop_in='/etc/systemd/system/consul.service.d/auto-sysv-migration.conf'
        if [ -f /etc/default/consul -a ! -f "${drop_in}" ]; then
            # be on the safe side and source /etc/default/consul in a subshell
            (
                . /etc/default/consul
                if [ "${WAIT_FOR_LEADER}" = no -o -n "${CONFIG_DIR}" ]; then
                    mkdir -p $(dirname "${drop_in}")
                    echo '[Service]' > "${drop_in}"
                    if [ "${WAIT_FOR_LEADER}" = no ]; then
                        echo "Environment=WAIT_FOR_LEADER=no" >> "${drop_in}"
                    fi
                    if [ -n "${CONFIG_DIR}" ]; then
                        echo "Environment=CONFIG_DIR=${CONFIG_DIR}" >> "${drop_in}"
                    fi

                    systemctl daemon-reload || true
                fi
            )
        fi
    ;;
    abort-upgrade|abort-remove|abort-deconfigure)
    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0
